Index: configuration-file/pure-ftpd.conf.in
===================================================================
--- configuration-file/pure-ftpd.conf.in.orig	2012-11-27 13:24:10.707338486 +0100
+++ configuration-file/pure-ftpd.conf.in	2012-11-27 13:29:18.283974068 +0100
@@ -37,7 +37,7 @@
 
 # Maximum number of simultaneous users
 
-MaxClientsNumber            50
+MaxClientsNumber            10
 
 
 
@@ -49,7 +49,7 @@
 
 # Maximum number of sim clients with the same IP address
 
-MaxClientsPerIP             8
+MaxClientsPerIP             3
 
 
 
@@ -59,6 +59,9 @@
 VerboseLog                  no
 
 
+# Allow dot-files
+AllowDotFiles               yes
+
 
 # List dot-files even when the client doesn't send "-a".
 
@@ -68,7 +71,7 @@
 
 # Don't allow authenticated users - have a public anonymous FTP only.
 
-AnonymousOnly               no
+AnonymousOnly               yes
 
 
 
@@ -107,23 +110,23 @@
 
 # LDAP configuration file (see README.LDAP)
 
-# LDAPConfigFile                /etc/pureftpd-ldap.conf
+# LDAPConfigFile                /etc/pure-ftpd/pureftpd-ldap.conf
 
 
 
 # MySQL configuration file (see README.MySQL)
 
-# MySQLConfigFile               /etc/pureftpd-mysql.conf
+# MySQLConfigFile               /etc/pure-ftpd/pureftpd-mysql.conf
 
 
 # Postgres configuration file (see README.PGSQL)
 
-# PGSQLConfigFile               /etc/pureftpd-pgsql.conf
+# PGSQLConfigFile               /etc/pure-ftpd/pureftpd-pgsql.conf
 
 
 # PureDB user database (see README.Virtual-Users)
 
-# PureDB                        /etc/pureftpd.pdb
+# PureDB                        /etc/pure-ftpd/pureftpd.pdb
 
 
 # Path to pure-authd socket (see README.Authentication-Modules)
@@ -134,7 +137,7 @@
 
 # If you want to enable PAM authentication, uncomment the following line
 
-# PAMAuthentication             yes
+PAMAuthentication             yes
 
 
 
@@ -177,7 +180,7 @@
 
 # Port range for passive connections replies. - for firewalling.
 
-# PassivePortRange          30000 50000
+PassivePortRange                30000 30100
 
 
 
@@ -227,12 +230,23 @@
 # UserBandwidth             8
 
 
-
 # File creation mask. <umask for files>:<umask for dirs> .
 # 177:077 if you feel paranoid.
 
-Umask                       133:022
+# Note: on SUSE systems umask is overrided by pam_umask inherited from
+# /etc/pam.d/common-session. In case the system-wide default does not
+# fit you, you can either
+#
+# 1.) add line 'session optional pam_umask.so umask=$value' into
+# /etc/pam.d/pure-ftpd, so all changes in common-session will apply
+# for pure-ftpd as well, but this value will be still ignored
+#
+# 2.) replace the line 'session include common-session' in
+# /etc/pam.d/pure-ftpd by the content of /etc/pam.d/common-session,
+# remove the line 'session optional pam_umask.so' and uncomment the
+# line below, but you will lose the changes maded to common-session
 
+#Umask                       133:022
 
 
 # Minimum UID for an authenticated user to log in.
@@ -257,7 +271,7 @@
 # even if they own them. If TrustedGID is enabled, this group
 # will have access to dot-files, though.
 
-ProhibitDotFilesWrite       no
+ProhibitDotFilesWrite       yes
 
 
 
@@ -270,13 +284,13 @@
 # Never overwrite files. When a file whoose name already exist is uploaded,
 # it get automatically renamed to file.1, file.2, file.3, ...
 
-AutoRename                  no
+AutoRename                  yes
 
 
 
 # Disallow anonymous users to upload new files (no = upload is allowed)
 
-AnonymousCantUpload         no
+AnonymousCantUpload         yes
 
 
 
@@ -372,7 +386,7 @@
 
 # Set to 'yes' if you don't want your users to rename files.
 
-#NoRename                  yes
+NoRename                  yes
 
 
 
@@ -442,3 +456,4 @@
 
 # FileSystemCharset	big5
 # ClientCharset		big5
+
Index: pureftpd-mysql.conf
===================================================================
--- pureftpd-mysql.conf.orig	2012-11-27 13:24:10.707338486 +0100
+++ pureftpd-mysql.conf	2012-11-27 13:24:12.135387863 +0100
@@ -19,17 +19,18 @@
 
 # Optional : define the location of mysql.sock if the server runs on this host.
 
-MYSQLSocket     /tmp/mysql.sock
+MYSQLSocket     /var/lib/mysql/mysql.sock
 
 
 # Mandatory : user to bind the server as.
-
-MYSQLUser       root
-
+#
+# using the Database root user is always a bad idea.
+#
+MYSQLUser       ftpd
 
 # Mandatory : user password. You must have a password.
 
-MYSQLPassword   rootpw
+MYSQLPassword   ftpdpw
 
 
 # Mandatory : database to open.
Index: pureftpd-pgsql.conf
===================================================================
--- pureftpd-pgsql.conf.orig	2012-11-27 13:24:10.707338486 +0100
+++ pureftpd-pgsql.conf	2012-11-27 13:24:12.135387863 +0100
@@ -16,6 +16,7 @@
 # PGSQLPort       .s.PGSQL.5432
 
 # Mandatory : user to bind the server as.
+
 PGSQLUser       postgres
 
 # Mandatory : user password. You *must* have a password.