--- configure
+++ configure
@@ -24608,169 +24608,13 @@
 $as_echo "no" >&6; }
 fi
 
-{ $as_echo "$as_me:$LINENO: checking default TCP send buffer size" >&5
-$as_echo_n "checking default TCP send buffer size... " >&6; }
-if test "$cross_compiling" = yes; then
-  CONF_TCP_SO_SNDBUF=65536
-else
-  cat >conftest.$ac_ext <<_ACEOF
-/* confdefs.h.  */
-_ACEOF
-cat confdefs.h >>conftest.$ac_ext
-cat >>conftest.$ac_ext <<_ACEOF
-/* end confdefs.h.  */
-
-#include <stdio.h>
-#ifdef STDC_HEADERS
-# include <stdlib.h>
-# include <stddef.h>
-#else
-# if HAVE_STDLIB_H
-#  include <stdlib.h>
-# endif
-#endif
-#ifdef HAVE_UNISTD_H
-# include <unistd.h>
-#endif
-#include <sys/types.h>
-#include <sys/socket.h>
-#include <netinet/in.h>
-int main(void)
-{
-    int fd,val=0,len=sizeof(int);
-    if ((fd = socket(PF_INET, SOCK_STREAM, 0)) < 0) return 1;
-        if (getsockopt(fd, SOL_SOCKET, SO_SNDBUF, &val, &len) < 0) return 1;
-    if (val <= 0) return 1;
-        fprintf (fopen("conftestval", "w"), "%d\n", val);
-    return 0;
-}
-
-_ACEOF
-rm -f conftest$ac_exeext
-if { (ac_try="$ac_link"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:$LINENO: $ac_try_echo\""
-$as_echo "$ac_try_echo") >&5
-  (eval "$ac_link") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:$LINENO: \$? = $ac_status" >&5
-  (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:$LINENO: $ac_try_echo\""
-$as_echo "$ac_try_echo") >&5
-  (eval "$ac_try") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:$LINENO: \$? = $ac_status" >&5
-  (exit $ac_status); }; }; then
-  CONF_TCP_SO_SNDBUF=`cat conftestval`
-else
-  $as_echo "$as_me: program exited with status $ac_status" >&5
-$as_echo "$as_me: failed program was:" >&5
-sed 's/^/| /' conftest.$ac_ext >&5
-
-( exit $ac_status )
-CONF_TCP_SO_SNDBUF=65536
-fi
-rm -rf conftest.dSYM
-rm -f core *.core core.conftest.* gmon.out bb.out conftest$ac_exeext conftest.$ac_objext conftest.$ac_ext
-fi
-
-
-{ $as_echo "$as_me:$LINENO: result: $CONF_TCP_SO_SNDBUF" >&5
-$as_echo "$CONF_TCP_SO_SNDBUF" >&6; }
-
-
 cat >>confdefs.h <<_ACEOF
-#define CONF_TCP_SO_SNDBUF $CONF_TCP_SO_SNDBUF
+#define CONF_TCP_SO_SNDBUF 65536
 _ACEOF
 
 
-{ $as_echo "$as_me:$LINENO: checking default TCP receive buffer size" >&5
-$as_echo_n "checking default TCP receive buffer size... " >&6; }
-if test "$cross_compiling" = yes; then
-  CONF_TCP_SO_RCVBUF=65536
-else
-  cat >conftest.$ac_ext <<_ACEOF
-/* confdefs.h.  */
-_ACEOF
-cat confdefs.h >>conftest.$ac_ext
-cat >>conftest.$ac_ext <<_ACEOF
-/* end confdefs.h.  */
-
-#include <stdio.h>
-#ifdef STDC_HEADERS
-# include <stdlib.h>
-# include <stddef.h>
-#else
-# if HAVE_STDLIB_H
-#  include <stdlib.h>
-# endif
-#endif
-#ifdef HAVE_UNISTD_H
-# include <unistd.h>
-#endif
-#include <sys/types.h>
-#include <sys/socket.h>
-#include <netinet/in.h>
-int main(void)
-{
-    int fd,val=0,len=sizeof(int);
-    if ((fd = socket(PF_INET, SOCK_STREAM, 0)) < 0) return 1;
-        if (getsockopt(fd, SOL_SOCKET, SO_RCVBUF, &val, &len) < 0) return 1;
-    if (val <= 0) return 1;
-        fprintf (fopen("conftestval", "w"), "%d\n", val);
-    return 0;
-}
-
-_ACEOF
-rm -f conftest$ac_exeext
-if { (ac_try="$ac_link"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:$LINENO: $ac_try_echo\""
-$as_echo "$ac_try_echo") >&5
-  (eval "$ac_link") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:$LINENO: \$? = $ac_status" >&5
-  (exit $ac_status); } && { ac_try='./conftest$ac_exeext'
-  { (case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval ac_try_echo="\"\$as_me:$LINENO: $ac_try_echo\""
-$as_echo "$ac_try_echo") >&5
-  (eval "$ac_try") 2>&5
-  ac_status=$?
-  $as_echo "$as_me:$LINENO: \$? = $ac_status" >&5
-  (exit $ac_status); }; }; then
-  CONF_TCP_SO_RCVBUF=`cat conftestval`
-else
-  $as_echo "$as_me: program exited with status $ac_status" >&5
-$as_echo "$as_me: failed program was:" >&5
-sed 's/^/| /' conftest.$ac_ext >&5
-
-( exit $ac_status )
-CONF_TCP_SO_RCVBUF=65536
-fi
-rm -rf conftest.dSYM
-rm -f core *.core core.conftest.* gmon.out bb.out conftest$ac_exeext conftest.$ac_objext conftest.$ac_ext
-fi
-
-
-{ $as_echo "$as_me:$LINENO: result: $CONF_TCP_SO_RCVBUF" >&5
-$as_echo "$CONF_TCP_SO_RCVBUF" >&6; }
-
-
 cat >>confdefs.h <<_ACEOF
-#define CONF_TCP_SO_RCVBUF $CONF_TCP_SO_RCVBUF
+#define CONF_TCP_SO_RCVBUF 65536
 _ACEOF
 
 